"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from enum import Enum
from friendliai.types import BaseModel
from typing import Optional
from typing_extensions import NotRequired, TypedDict


class ToolMessageRole(str, Enum):
    r"""The role of the messages author."""

    TOOL = "tool"


class ToolMessageTypedDict(TypedDict):
    role: ToolMessageRole
    r"""The role of the messages author."""
    content: str
    r"""The content of tool message that contains the result of tool calling."""
    tool_call_id: str
    r"""The ID of tool call corresponding to this message."""
    name: NotRequired[str]
    r"""An optional name of the tool call corresponding to this message."""


class ToolMessage(BaseModel):
    role: ToolMessageRole
    r"""The role of the messages author."""

    content: str
    r"""The content of tool message that contains the result of tool calling."""

    tool_call_id: str
    r"""The ID of tool call corresponding to this message."""

    name: Optional[str] = None
    r"""An optional name of the tool call corresponding to this message."""
